# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from youtube_ti.models.abuse_type import AbuseType
from youtube_ti.models.entity import Entity
from youtube_ti.models.related_entity import RelatedEntity
from typing import Optional, Set
from typing_extensions import Self

class AbuseReport(BaseModel):
    """
    AbuseReport
    """ # noqa: E501
    abuse_types: Optional[List[AbuseType]] = Field(default=None, alias="abuseTypes")
    description: Optional[StrictStr] = None
    related_entities: Optional[List[RelatedEntity]] = Field(default=None, alias="relatedEntities")
    subject: Optional[Entity] = None
    __properties: ClassVar[List[str]] = ["abuseTypes", "description", "relatedEntities", "subject"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AbuseReport from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in abuse_types (list)
        _items = []
        if self.abuse_types:
            for _item_abuse_types in self.abuse_types:
                if _item_abuse_types:
                    _items.append(_item_abuse_types.to_dict())
            _dict['abuseTypes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in related_entities (list)
        _items = []
        if self.related_entities:
            for _item_related_entities in self.related_entities:
                if _item_related_entities:
                    _items.append(_item_related_entities.to_dict())
            _dict['relatedEntities'] = _items
        # override the default output from pydantic by calling `to_dict()` of subject
        if self.subject:
            _dict['subject'] = self.subject.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AbuseReport from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "abuseTypes": [AbuseType.from_dict(_item) for _item in obj["abuseTypes"]] if obj.get("abuseTypes") is not None else None,
            "description": obj.get("description"),
            "relatedEntities": [RelatedEntity.from_dict(_item) for _item in obj["relatedEntities"]] if obj.get("relatedEntities") is not None else None,
            "subject": Entity.from_dict(obj["subject"]) if obj.get("subject") is not None else None
        })
        return _obj


