# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Cuepoint(BaseModel):
    """
    Note that there may be a 5-second end-point resolution issue. For instance, if a cuepoint comes in for 22:03:27, we may stuff the cuepoint into 22:03:25 or 22:03:30, depending. This is an artifact of HLS.
    """ # noqa: E501
    cue_type: Optional[StrictStr] = Field(default=None, alias="cueType")
    duration_secs: Optional[StrictInt] = Field(default=None, description="The duration of this cuepoint.", alias="durationSecs")
    etag: Optional[StrictStr] = None
    id: Optional[StrictStr] = Field(default=None, description="The identifier for cuepoint resource.")
    insertion_offset_time_ms: Optional[StrictStr] = Field(default=None, description="The time when the cuepoint should be inserted by offset to the broadcast actual start time.", alias="insertionOffsetTimeMs")
    walltime_ms: Optional[StrictStr] = Field(default=None, description="The wall clock time at which the cuepoint should be inserted. Only one of insertion_offset_time_ms and walltime_ms may be set at a time.", alias="walltimeMs")
    __properties: ClassVar[List[str]] = ["cueType", "durationSecs", "etag", "id", "insertionOffsetTimeMs", "walltimeMs"]

    @field_validator('cue_type')
    def cue_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['cueTypeUnspecified', 'cueTypeAd']):
            raise ValueError("must be one of enum values ('cueTypeUnspecified', 'cueTypeAd')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Cuepoint from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Cuepoint from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cueType": obj.get("cueType"),
            "durationSecs": obj.get("durationSecs"),
            "etag": obj.get("etag"),
            "id": obj.get("id"),
            "insertionOffsetTimeMs": obj.get("insertionOffsetTimeMs"),
            "walltimeMs": obj.get("walltimeMs")
        })
        return _obj


