# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from youtube_ti.models.cdn_settings import CdnSettings
from youtube_ti.models.live_stream_content_details import LiveStreamContentDetails
from youtube_ti.models.live_stream_snippet import LiveStreamSnippet
from youtube_ti.models.live_stream_status import LiveStreamStatus
from typing import Optional, Set
from typing_extensions import Self

class LiveStream(BaseModel):
    """
    A live stream describes a live ingestion point.
    """ # noqa: E501
    cdn: Optional[CdnSettings] = None
    content_details: Optional[LiveStreamContentDetails] = Field(default=None, alias="contentDetails")
    etag: Optional[StrictStr] = Field(default=None, description="Etag of this resource.")
    id: Optional[StrictStr] = Field(default=None, description="The ID that YouTube assigns to uniquely identify the stream.")
    kind: Optional[StrictStr] = Field(default='youtube#liveStream', description="Identifies what kind of resource this is. Value: the fixed string \"youtube#liveStream\".")
    snippet: Optional[LiveStreamSnippet] = None
    status: Optional[LiveStreamStatus] = None
    __properties: ClassVar[List[str]] = ["cdn", "contentDetails", "etag", "id", "kind", "snippet", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LiveStream from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cdn
        if self.cdn:
            _dict['cdn'] = self.cdn.to_dict()
        # override the default output from pydantic by calling `to_dict()` of content_details
        if self.content_details:
            _dict['contentDetails'] = self.content_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of snippet
        if self.snippet:
            _dict['snippet'] = self.snippet.to_dict()
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LiveStream from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cdn": CdnSettings.from_dict(obj["cdn"]) if obj.get("cdn") is not None else None,
            "contentDetails": LiveStreamContentDetails.from_dict(obj["contentDetails"]) if obj.get("contentDetails") is not None else None,
            "etag": obj.get("etag"),
            "id": obj.get("id"),
            "kind": obj.get("kind") if obj.get("kind") is not None else 'youtube#liveStream',
            "snippet": LiveStreamSnippet.from_dict(obj["snippet"]) if obj.get("snippet") is not None else None,
            "status": LiveStreamStatus.from_dict(obj["status"]) if obj.get("status") is not None else None
        })
        return _obj


