# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from youtube_ti.models.language_tag import LanguageTag
from youtube_ti.models.localized_string import LocalizedString
from typing import Optional, Set
from typing_extensions import Self

class LocalizedProperty(BaseModel):
    """
    LocalizedProperty
    """ # noqa: E501
    default: Optional[StrictStr] = None
    default_language: Optional[LanguageTag] = Field(default=None, alias="defaultLanguage")
    localized: Optional[List[LocalizedString]] = None
    __properties: ClassVar[List[str]] = ["default", "defaultLanguage", "localized"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LocalizedProperty from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of default_language
        if self.default_language:
            _dict['defaultLanguage'] = self.default_language.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in localized (list)
        _items = []
        if self.localized:
            for _item_localized in self.localized:
                if _item_localized:
                    _items.append(_item_localized.to_dict())
            _dict['localized'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LocalizedProperty from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "default": obj.get("default"),
            "defaultLanguage": LanguageTag.from_dict(obj["defaultLanguage"]) if obj.get("defaultLanguage") is not None else None,
            "localized": [LocalizedString.from_dict(_item) for _item in obj["localized"]] if obj.get("localized") is not None else None
        })
        return _obj


