# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from youtube_ti.models.third_party_link_snippet import ThirdPartyLinkSnippet
from youtube_ti.models.third_party_link_status import ThirdPartyLinkStatus
from typing import Optional, Set
from typing_extensions import Self

class ThirdPartyLink(BaseModel):
    """
    A *third party account link* resource represents a link between a YouTube account or a channel and an account on a third-party service.
    """ # noqa: E501
    etag: Optional[StrictStr] = Field(default=None, description="Etag of this resource")
    kind: Optional[StrictStr] = Field(default='youtube#thirdPartyLink', description="Identifies what kind of resource this is. Value: the fixed string \"youtube#thirdPartyLink\".")
    linking_token: Optional[StrictStr] = Field(default=None, description="The linking_token identifies a YouTube account and channel with which the third party account is linked.", alias="linkingToken")
    snippet: Optional[ThirdPartyLinkSnippet] = None
    status: Optional[ThirdPartyLinkStatus] = None
    __properties: ClassVar[List[str]] = ["etag", "kind", "linkingToken", "snippet", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ThirdPartyLink from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of snippet
        if self.snippet:
            _dict['snippet'] = self.snippet.to_dict()
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ThirdPartyLink from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "etag": obj.get("etag"),
            "kind": obj.get("kind") if obj.get("kind") is not None else 'youtube#thirdPartyLink',
            "linkingToken": obj.get("linkingToken"),
            "snippet": ThirdPartyLinkSnippet.from_dict(obj["snippet"]) if obj.get("snippet") is not None else None,
            "status": ThirdPartyLinkStatus.from_dict(obj["status"]) if obj.get("status") is not None else None
        })
        return _obj


