# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from youtube_ti.models.thumbnail import Thumbnail
from typing import Optional, Set
from typing_extensions import Self

class ThumbnailDetails(BaseModel):
    """
    Internal representation of thumbnails for a YouTube resource.
    """ # noqa: E501
    default: Optional[Thumbnail] = None
    high: Optional[Thumbnail] = None
    maxres: Optional[Thumbnail] = None
    medium: Optional[Thumbnail] = None
    standard: Optional[Thumbnail] = None
    __properties: ClassVar[List[str]] = ["default", "high", "maxres", "medium", "standard"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ThumbnailDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of default
        if self.default:
            _dict['default'] = self.default.to_dict()
        # override the default output from pydantic by calling `to_dict()` of high
        if self.high:
            _dict['high'] = self.high.to_dict()
        # override the default output from pydantic by calling `to_dict()` of maxres
        if self.maxres:
            _dict['maxres'] = self.maxres.to_dict()
        # override the default output from pydantic by calling `to_dict()` of medium
        if self.medium:
            _dict['medium'] = self.medium.to_dict()
        # override the default output from pydantic by calling `to_dict()` of standard
        if self.standard:
            _dict['standard'] = self.standard.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ThumbnailDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "default": Thumbnail.from_dict(obj["default"]) if obj.get("default") is not None else None,
            "high": Thumbnail.from_dict(obj["high"]) if obj.get("high") is not None else None,
            "maxres": Thumbnail.from_dict(obj["maxres"]) if obj.get("maxres") is not None else None,
            "medium": Thumbnail.from_dict(obj["medium"]) if obj.get("medium") is not None else None,
            "standard": Thumbnail.from_dict(obj["standard"]) if obj.get("standard") is not None else None
        })
        return _obj


