# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class VideoStatistics(BaseModel):
    """
    Statistics about the video, such as the number of times the video was viewed or liked.
    """ # noqa: E501
    comment_count: Optional[StrictStr] = Field(default=None, description="The number of comments for the video.", alias="commentCount")
    dislike_count: Optional[StrictStr] = Field(default=None, description="The number of users who have indicated that they disliked the video by giving it a negative rating.", alias="dislikeCount")
    favorite_count: Optional[StrictStr] = Field(default=None, description="The number of users who currently have the video marked as a favorite video.", alias="favoriteCount")
    like_count: Optional[StrictStr] = Field(default=None, description="The number of users who have indicated that they liked the video by giving it a positive rating.", alias="likeCount")
    view_count: Optional[StrictStr] = Field(default=None, description="The number of times the video has been viewed.", alias="viewCount")
    __properties: ClassVar[List[str]] = ["commentCount", "dislikeCount", "favoriteCount", "likeCount", "viewCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VideoStatistics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VideoStatistics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "commentCount": obj.get("commentCount"),
            "dislikeCount": obj.get("dislikeCount"),
            "favoriteCount": obj.get("favoriteCount"),
            "likeCount": obj.get("likeCount"),
            "viewCount": obj.get("viewCount")
        })
        return _obj


